[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Message-Id: <1569516532-708-3-git-send-email-yanhaishuang@cmss.chinamobile.com>
Date: Fri, 27 Sep 2019 00:48:51 +0800
From: Haishuang Yan <yanhaishuang@...s.chinamobile.com>
To: Shuah Khan <shuah@...nel.org>,
Pablo Neira Ayuso <pablo@...filter.org>,
"David S. Miller" <davem@...emloft.net>
Cc: Julian Anastasov <ja@....bg>, linux-kernel@...r.kernel.org,
linux-kselftest@...r.kernel.org,
Haishuang Yan <yanhaishuang@...s.chinamobile.com>
Subject: [PATCH 2/3] selftests: netfilter: add ipvs nat test case
Test virtual server via NAT.
Tested:
# selftests: netfilter: ipvs.sh
# Testing DR mode...
# Testing NAT mode...
# ipvs.sh: PASS
Signed-off-by: Haishuang Yan <yanhaishuang@...s.chinamobile.com>
---
tools/testing/selftests/netfilter/ipvs.sh | 22 +++++++++++++++++++++-
1 file changed, 21 insertions(+), 1 deletion(-)
diff --git a/tools/testing/selftests/netfilter/ipvs.sh b/tools/testing/selftests/netfilter/ipvs.sh
index 15c386b..40058f9 100755
--- a/tools/testing/selftests/netfilter/ipvs.sh
+++ b/tools/testing/selftests/netfilter/ipvs.sh
@@ -153,20 +153,40 @@ test_dr() {
test_service
}
+test_nat() {
+ ip netns exec ns0 ip route add ${vip_v4} via ${gip_v4} dev br0
+
+ ip netns exec ns1 sysctl -qw net.ipv4.ip_forward=1
+ ip netns exec ns1 ipvsadm -A -t ${vip_v4}:${port} -s rr
+ ip netns exec ns1 ipvsadm -a -m -t ${vip_v4}:${port} -r ${rip_v4}:${port}
+ ip netns exec ns1 ip addr add ${vip_v4}/32 dev lo:1
+
+ ip netns exec ns2 ip link del veth20
+ ip netns exec ns2 ip route add default via ${dip_v4} dev veth21
+
+ test_service
+}
+
run_tests() {
local errors=
echo "Testing DR mode..."
+ cleanup
setup
test_dr
errors=$(( $errors + $? ))
+ echo "Testing NAT mode..."
+ cleanup
+ setup
+ test_nat
+ errors=$(( $errors + $? ))
+
return $errors
}
trap cleanup EXIT
-cleanup
run_tests
if [ $? -ne 0 ]; then
--
1.8.3.1
Powered by blists - more mailing lists